CROSS_COMPILE =
CC := $(CROSS_COMPILE)gcc
STRIP := $(CROSS_COMPILE)strip
MCU_DEVICE =
CFLAGS:=-Wall -fPIC -DMCU_DEVICE=\"$(MCU_DEVICE)\"
LIB := mx-lanbypass
UTIL := mx-lanbypass-ctl
DESTDIR ?= /

all: clean $(UTIL)

$(LIB).a:
	@if [ -z $(MCU_DEVICE) ]; then \
		echo "Please define MCU device name! e.g. MCU_DEVICE=/dev/ttyS2"; \
		exit 1; \
	fi
	gcc $(CFLAGS) $(DEBUG) -c $(LIB).c
	ar r $(LIB).a $(LIB).o

$(UTIL): $(UTIL).c $(LIB).a lib$(LIB).so
	$(CC) $(DEBUG) -o $(UTIL) $(UTIL).c -L. $(LIB).a
	$(STRIP) -s $(UTIL)

lib%.so: $(LIB).c
	$(CC) $(CFLAGS) -shared -I.  -o $@ $<

install:
	@/usr/bin/install -d $(DESTDIR)/sbin
	@/usr/bin/install $(UTIL) $(DESTDIR)/sbin/$(UTIL)

debug: DEBUG = -DDEBUG
debug: clean $(UTIL)

.PHONY: clean
clean:
	rm -f $(UTIL) *.a *.o *.so $(DESTDIR)/sbin/$(UTIL)